// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement, QedaPattern, QedaSymbol,
    slice = [].slice;

  QedaSymbol = require('./qeda-symbol');

  QedaPattern = require('./qeda-pattern');

  QedaElement = (function() {
    function QedaElement(library, definition) {
      var alias, i, j, key, l, last, len, len1, len2, m, name, number, o, p, part, pins, q, ref, ref1, ref2, ref3, ref4, ref5, ref6, suffix, suffixes, value;
      this.library = library;
      this.mergeObjects(this, definition);
      if (this.alias != null) {
        if (this.aliases == null) {
          this.aliases = [];
        }
        this.aliases.concat(this.alias.replace(/\s+/g, '').split(','));
      }
      if (this.suffix != null) {
        if (this.aliases == null) {
          this.aliases = [];
        }
        suffixes = this.suffix.replace(/\s+/g, '').split(',');
        for (l = 0, len = suffixes.length; l < len; l++) {
          suffix = suffixes[l];
          alias = this.name + suffix;
          if (this.aliases.indexOf(alias) === -1) {
            this.aliases.push(alias);
          }
        }
      }
      this.longestAlias = this.name;
      if (this.alias != null) {
        ref = this.alias;
        for (m = 0, len1 = ref.length; m < len1; m++) {
          alias = ref[m];
          if (alias.length > this.longestAlias.length) {
            this.longestAlias = alias;
          }
        }
      }
      this.refDes = 'REF';
      this.symbols = [];
      this.pattern = new QedaPattern(this);
      this.pins = [];
      this.pinGroups = [];
      this._letters = ['', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'R', 'T', 'U', 'V', 'W', 'Y'];
      last = this._letters.length - 1;
      for (i = o = 1, ref1 = last; 1 <= ref1 ? o <= ref1 : o >= ref1; i = 1 <= ref1 ? ++o : --o) {
        for (j = p = ref2 = i, ref3 = last; ref2 <= ref3 ? p <= ref3 : p >= ref3; j = ref2 <= ref3 ? ++p : --p) {
          this._letters.push(this._letters[i] + this._letters[j]);
        }
      }
      ref4 = this.pinout;
      for (name in ref4) {
        value = ref4[name];
        pins = this._addPins(value);
        this.pinGroups[name] = pins;
        if (typeof value === 'object') {
          continue;
        }
        for (q = 0, len2 = pins.length; q < len2; q++) {
          number = pins[q];
          if (this.pins[number] == null) {
            this.pins[number] = this._pinObj(number, name);
          } else {
            this.pins[number].name += '/' + name;
          }
        }
      }
      ref5 = this.groups;
      for (key in ref5) {
        value = ref5[key];
        this.pinGroups[key] = this._concatenateGroups(value);
      }
      if (this.parts != null) {
        ref6 = this.parts;
        for (name in ref6) {
          part = ref6[name];
          this.symbols.push(new QedaSymbol(this, part.replace(/\s+/g, '').split(','), name));
        }
      } else {
        part = [];
        if (this.groups != null) {
          for (key in this.groups) {
            part.push(key);
          }
        } else {
          for (key in this.pinout) {
            part.push(key);
          }
        }
        this.symbols.push(new QedaSymbol(this, part));
      }
    }

    QedaElement.prototype.isFloat = function(n) {
      return Number(n) && (n % 1 !== 0);
    };

    QedaElement.prototype.mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && (!Array.isArray(v)) && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaElement.prototype.render = function() {
      var base, cap, def, handler, l, len, len1, m, outline, ref, ref1, ref2, ref3, symbol;
      if (this._rendered == null) {
        this._rendered = false;
      }
      if (this._rendered) {
        return;
      }
      handler = require("./element/" + this.library.elementStyle);
      handler(this);
      ref = this.symbols;
      for (l = 0, len = ref.length; l < len; l++) {
        symbol = ref[l];
        if (((ref1 = this.schematic) != null ? ref1.symbol : void 0) != null) {
          handler = require("./symbol/" + this.library.symbolStyle + "/" + (this.schematic.symbol.toLowerCase()));
          handler(symbol);
        }
      }
      if (((ref2 = this.housing) != null ? ref2.outline : void 0) != null) {
        outline = this.housing.outline;
        ref3 = this.library.outlineDefs;
        for (m = 0, len1 = ref3.length; m < len1; m++) {
          def = ref3[m];
          cap = def.regexp.exec(outline);
          if (cap) {
            handler = require("./outline/" + def.handler);
            handler.apply(null, [this.housing].concat(slice.call(cap.slice(1))));
          }
        }
      }
      this._convertDimensions(this.housing);
      handler = require("./pattern/" + this.library.patternStyle + "/" + this.pattern.handler);
      handler(this.pattern, this.housing);
      if ((base = this.pattern).name == null) {
        base.name = this.housing.pattern;
      }
      return this._rendered = true;
    };

    QedaElement.prototype._addPins = function(value) {
      var cap, i, j, l, len, len1, m, name, number, numbers, o, p, pins, ref, ref1, ref2, ref3, result;
      result = [];
      if (typeof value === 'object') {
        for (name in value) {
          numbers = value[name];
          pins = this._addPins(numbers);
          for (l = 0, len = pins.length; l < len; l++) {
            number = pins[l];
            if (this.pins[number] == null) {
              this.pins[number] = this._pinObj(number, name);
            } else {
              this.pins[number].name += '/' + name;
            }
          }
          result = result.concat(pins);
        }
      } else {
        if (typeof value === 'number') {
          value = value.toString();
        }
        numbers = value.replace(/\s+/g, '').split(',');
        for (m = 0, len1 = numbers.length; m < len1; m++) {
          number = numbers[m];
          cap = /([A-Z]*)(\d+)-([A-Z]*)(\d+)/.exec(number);
          if (!cap) {
            result.push(number);
          } else {
            for (i = o = ref = this._letters.indexOf(cap[1]), ref1 = this._letters.indexOf(cap[3]); ref <= ref1 ? o <= ref1 : o >= ref1; i = ref <= ref1 ? ++o : --o) {
              for (j = p = ref2 = cap[2], ref3 = cap[4]; ref2 <= ref3 ? p <= ref3 : p >= ref3; j = ref2 <= ref3 ? ++p : --p) {
                result.push(this._letters[i] + j);
              }
            }
          }
        }
      }
      return result;
    };

    QedaElement.prototype._concatenateGroups = function(groups) {
      var group, l, len, pinGroup, result;
      result = [];
      groups = groups.replace(/\s+/g, '').split(',');
      for (l = 0, len = groups.length; l < len; l++) {
        group = groups[l];
        pinGroup = this.pinGroups[group];
        if (pinGroup != null) {
          result = result.concat(pinGroup);
        }
      }
      return result;
    };

    QedaElement.prototype._convertDimensions = function(housing) {
      var key, max, min, nom, results, tol, value;
      results = [];
      for (key in housing) {
        value = housing[key];
        if (typeof value === 'string') {
          value = value.replace(/\s+/g, '').split(',').map(function(a) {
            return parseFloat(a);
          });
        }
        if (Array.isArray(value) && value.length > 0) {
          min = value[0];
          max = value.length > 1 ? value[1] : min;
          nom = (max + min) / 2;
          tol = max - min;
          results.push(housing[key] = {
            min: min,
            max: max,
            nom: nom,
            tol: tol
          });
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    QedaElement.prototype._pinObj = function(number, name) {
      var l, len, obj, pins, prop, props;
      obj = {
        name: name,
        number: number
      };
      if (this.properties != null) {
        props = ['bidir', 'ground', 'in', 'inverted', 'out', 'passive', 'power'];
        for (l = 0, len = props.length; l < len; l++) {
          prop = props[l];
          if (this.properties[prop] != null) {
            pins = this.properties[prop].replace(/\s+/g, '').split(',');
            obj[prop] = pins.indexOf(name) !== -1;
          }
        }
      }
      return obj;
    };

    return QedaElement;

  })();

  module.exports = QedaElement;

}).call(this);
